/**************************************************************
** 	ţ
**	: STM32ڲ
**  汾V1.0  
**	̳www.openmcu.com
**	Աhttp://shop36995246.taobao.com/   
**  ֧Ⱥ121939788 
***************************************************************/ 
#include "stm32f10x.h"
#include "USART.h"
#include <string.h>

/*****************************************************************************
** : USART1_Send_Byte
** : ڷһַ
**   : Dream
** ա  : 20101206
*****************************************************************************/
void USART1_Send_Byte(u16 Data)
{ 
   	while (!(USART1->SR & USART_FLAG_TXE));
   	USART1->DR = (Data & (uint16_t)0x01FF);	   
}
/*****************************************************************************
** : USART_Send_Str
** : ڷַ
				s:ַָָ 
					עַ'\n'ᷢһس
**   : Dream
** ա  : 20101206
*****************************************************************************/
void USART_Send_Str(const char* data)
{
	u16 i;
	u16 len = strlen(data)-1;
	for (i=0; i<len; i++)
	{
		USART1_Send_Byte(data[i]);
	}
	if(data[i]=='\n') 
	{
		USART_Send_Enter();
	}
	else
	{
		USART1_Send_Byte(data[i]);
	}		
}
/*****************************************************************************
** : USART_Send_Enter
** : ڷַ
				ڷ0d 0a س
					ע˺Ƿ0d 0aֽڣڡնˡϻлسеЧ
**   : Dream
** ա  : 20101206
*****************************************************************************/
void USART_Send_Enter(void)
{
	USART1_Send_Byte(0x0d);
	USART1_Send_Byte(0x0a);
}
/*****************************************************************************
** : USART_Put_Num
** : ڷֵ
				лὫֵתΪӦַͳȥ 4567 תΪ "4567" 
**   : Dream
** ա  : 20101206
*****************************************************************************/	
void USART_Put_Num(u32 dat)
{
 	char temp[20];
 	u32tostr(dat,temp);
 	USART_Send_Str(temp);
}
/*****************************************************************************
** : USART_Put_Inf
** : ڷ͵Ϣ
				inf:ָʾϢַָ
             dat:һֵǰʾϢ˵ֵ 
**   : Dream
** ա  : 20101206
*****************************************************************************/
void USART_Put_Inf(char *inf,u32 dat)
{
 	USART_Send_Str(inf);
 	USART_Put_Num(dat);
 	USART_Send_Str("\n");  
}
/*****************************************************************************
** : USART_Configuration
** : ú
				STM321 115200 
**   : Dream
** ա  : 20101206
*****************************************************************************/
void USART_Configuration(void)
{
	USART_InitTypeDef USART_InitStructure;
	USART_InitStructure.USART_BaudRate            = 115200  ;	  //115200
	USART_InitStructure.USART_WordLength          = USART_WordLength_8b; //8λ
	USART_InitStructure.USART_StopBits            = USART_StopBits_1;	 //ֹͣλ1λ
	USART_InitStructure.USART_Parity              = USART_Parity_No ;	 //
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	USART_InitStructure.USART_Mode                = USART_Mode_Rx | USART_Mode_Tx;
	USART_Init(USART1, &USART_InitStructure);
	USART_ITConfig(USART1, USART_IT_RXNE, ENABLE);
	USART_Cmd(USART1, ENABLE);     
}
/*****************************************************************************
** : USART1_IRQHandler
** : жϺ
**   : Dream
** ա  : 20101206
*****************************************************************************/
void USART1_IRQHandler(void)
{
	u8 c;
	if(USART_GetITStatus(USART1, USART_IT_RXNE) != RESET)
	{ 	
	    c=USART1->DR;
		USART1_Send_Byte(c); 	    
	} 
	 
}
/*****************************************************************************
** : u32tostr
** : һ32λıdatתΪַ1234תΪ"1234"
				dat:תlong͵ı
             str:ַָָ룬תֽڴ
**   : Dream
** ա  : 20101206
*****************************************************************************/
void u32tostr(u32 dat,char *str) 
{
 	char temp[20];
 	u8 i=0,j=0;
 	i=0;
 	while(dat)
 	{
  		temp[i]=dat%10+0x30;
  		i++;
  		dat/=10;
 	}
 	j=i;
 	for(i=0;i<j;i++)
 	{
  		str[i]=temp[j-i-1];
 	}
 	if(!i) {str[i++]='0';}
 	str[i]=0;
}
/*********************************************************************************************************
** End of File
*********************************************************************************************************/
